/*
Copyright (C) 2003 Hotsprings Inc.
For conditions of distribution and use, see copyright notice

Location: 
	www.HotspringsInc.com 

History:
	2003Apr10-GiuseppeG: code write
*/
namespace XSP
{
   // must be implemented by the app developer
   void MainEntryPoint();
   
   class AppExitCode
   {    // application level global static
   		static int& _exitCode() { static int _code = 0; return _code; }
   public:
   		static void SetExitCode(int code) { _exitCode() = code; }
   		static  int GetExitCode() { return _exitCode(); }
   };  // class AppExitCode
   
   class AppCmdLine
   {    // application level global static
   		static int& _argc() { static int _n = 0; return _n; }
   		static const char *const * & _argv() { static const char *const * _v = 0; return _v; }
   public:
   		static void SetARGC(int code) { _argc() = code; }
   		static  int GetARGC() { return _argc(); }

   		static void SetARGV(char** v) { _argv() = (const char *const *)v; }
   		static const char* GetARGV(int n) { return _argv()[n]; }
   };  // class AppExitCode
   
   class CoreVersion : public VersionInfo
   {
   public:
   		CoreVersion();
   };
   
   class CoreModule
   {
   public:
   		static CoreModule* _instance;
   		
   public:
   		CoreModule();
   		~CoreModule();

   public:
   		CoreVersion coreVersion;
   		RuntimeVersion runtimeVersion;
   		StringMessages stringMessages;
   		refc<EventLoop> mainLoop;
   };

} // namespace XSP


