/*
Copyright (C) 2003 Hotsprings Inc.
For conditions of distribution and use, see copyright notice

Location: 
	www.HotspringsInc.com 

History:
	2003Aug27-GiuseppeG: code write
*/

#include "XSP_Core.h"
#include "XSP_File.h"
#include "XSP_GUI.h"

namespace XSP
{

MouseCursor::_Data::_Data(HINSTANCE inst, const char* cursname)
{
// IDC_ARROW           MAKEINTRESOURCE(32512)
// IDC_IBEAM           MAKEINTRESOURCE(32513)
// IDC_HAND            MAKEINTRESOURCE(32649)
	 handle = LoadCursor(inst, cursname);
	 if (handle == NULL &&  inst != NULL)
		 handle = LoadCursor(NULL, cursname);
	 if (handle == NULL)
		 handle = LoadCursor(NULL, IDC_ARROW);
	 VERIFY(handle != NULL);
}
MouseCursor::_Data::~_Data()
{
}

MouseCursor::MouseCursor()
{
}
MouseCursor::~MouseCursor()
{
}
MouseCursor::MouseCursor(const MouseCursor& t)
: data(t.data)
{
}
MouseCursor::MouseCursor(_Data* t)
: data(t)
{
}
MouseCursor& MouseCursor::operator = (const MouseCursor& t)
{
	data = t.data;
	return *this;
}
MouseCursor& MouseCursor::operator = (const MouseCursor* t)
{
	data = t->data;
	return *this;
}
bool MouseCursor::operator == (const MouseCursor& t) const
{
	return data == t.data;
}
bool MouseCursor::operator != (const MouseCursor& t) const
{
	return data != t.data;
}
bool MouseCursor::operator == (const MouseCursor* t) const
{
	return data == t->data;
}
bool MouseCursor::operator != (const MouseCursor* t) const
{
	return data != t->data;
}




} // namespace XSP
